/* Copyright (c) 2014 by Boris van Schooten tmtg.net boris@13thmonkey.org */
// Released under BSD license. See LICENSE for details.

// TODO

// V credits
// V options (sound-music)
// V ingame instructions
// donate
// V icon + 512 icon + ouya icon
// fix firefox 31 bug (intermittent?)

// nice to have
// better flamethrower
// V text easing
// V fewer sound triggers
// V sound volume 50%
// V jump when fall
// V different shooting for plants

// constants

var width=1067, height=600;

var gamebasespeed = 1000/60;



// vars

var eng;


var gl;

var posBuffer, norm1Buffer, norm2Buffer, colorBuffer, dirBuffer;

var nrBuffer, sizeBuffer;

var lastTime = 0;
var timeElapsed = 1000/60;
var expectedTimeElapsed = 1000/60;
var gametime=0, gamespeed=1.0, totalgametime=0;

var frameskip=0;

var level=0, stage=0, lives=3;

var startlevel=0;

var stars = 15;

var score=0;

var highscore=0;

var bonussoundtrigger=0;


var cyclecol = [
	[1, 0, 0, 1],
	[1, 1, 0, 1],
	[0, 1, 0, 1],
	[0, 1, 1, 1],
	[0, 0, 1, 1],
	[1, 0, 1, 1],
];

var gamepadcontrols = false;
var touchcontrols = false;

var gamepadmx = 0;
var gamepadmy = 0;
var gamepadfx = 0;
var gamepadfy = 0;

var gamepaddx = 0;
var gamepaddy = 0;

var gamepadbut = false;
var prevgamepadbut = false;

var robot_texs = [];
var flyer_texs = [];
var fish_texs = [];
var flower_texs = [];
var gnat_texs = [];

var player_texs = [];
var playertitle_tex;

var star_texs = [];

var heart_tex;
var bullet_tex;
var seed_tex;

var bg_texs = [];

var tile_texs = [];
var tilemap;
var screenxofs = 0;

var unit_arrow = [
	0, -1,
	-1,0,
	-0.5,0,
	-0.5,1,
	0.5,1,
	0.5,0,
	1,0,
];


var font_color = [1,1,1,1];


var mainmenu;
var curmenu;


function resizeCanvas() {
	var canvas = document.getElementById("game-canvas");
	canvas.style.width = window.innerWidth;
	canvas.style.height = window.innerHeight;
	canvas.width = window.innerWidth;
	canvas.height = window.innerHeight;
}

function webGLStart() {
	window.addEventListener('resize', resizeCanvas, false);
	// init gl
	var canvas = document.getElementById("game-canvas");
	resizeCanvas();
	gl = createGL(canvas, {antialias:false, premultipliedAlpha: false});
	// use this to show verbose debug info in console
	//gl = WebGLDebugUtils.makeDebugContext(gl);

	eng = new JGEngine(canvas,width,height);
	eng.setGameState("Title",-1);

	gldrawInit();

	if (localStorage) {
		highscore = localStorage.getItem("highscore");
		if (!highscore) highscore=0;
	}

	JGAudio.load("explou0","sounds/roof-kill1b");
	JGAudio.load("explou1","sounds/roof-kill2b");
	JGAudio.load("explou2","sounds/roof-kill3b");
	//JGAudio.load("explou0","sounds/ramboexplo1");
	//JGAudio.load("explou1","sounds/ramboexplo1");
	//JGAudio.load("explou2","sounds/ramboexplo1");
	JGAudio.load("bonusb0","sounds/fins_success-1_cc_0-dsharp");
	JGAudio.load("bonusb1","sounds/fins_success-1_cc_0-asharp");
	JGAudio.load("bonusb2","sounds/fins_success-1_cc_0-asharp-2");
	JGAudio.load("bonusa0","sounds/fins__scale-asharp-0");
	JGAudio.load("bonusa1","sounds/fins__scale-dsharp");
	JGAudio.load("bonusa2","sounds/fins__scale-asharp");
	JGAudio.load("pop0","sounds/170964__timgormly__metal-ping1_cc_by");
	JGAudio.load("pop1","sounds/170964__timgormly__metal-ping1_cc_by");
	JGAudio.load("pop2","sounds/170964__timgormly__metal-ping1_cc_by");
	JGAudio.load("jump0","sounds/pacdv_sound115_jump-asharp-0");
	JGAudio.load("jump1","sounds/pacdv_sound115_jump-dsharp");
	JGAudio.load("jump2","sounds/pacdv_sound115_jump-asharp");
	JGAudio.load("bounce0","sounds/ivanbailey__1234567_cc_by-dsharpb");
	JGAudio.load("bounce1","sounds/ivanbailey__1234567_cc_by-dsharp-50pct");
	JGAudio.load("bounce2","sounds/ivanbailey__1234567_cc_by-dsharp-terts");
	JGAudio.load("ouch0","sounds/ouch1-qubodup_cc_by");
	JGAudio.load("leveldone","sounds/162395__zut50__yay_cc_0");
	JGAudio.load("spit0","sounds/spit1_erikh2000_cc_0");
	JGAudio.load("spit1","sounds/spit2_erikh2000_cc_0");
	JGAudio.load("death0","sounds/crash1-nothayama_cc_by");
	JGAudio.load("death1","sounds/crash2b-bone666138_cc_by");
	JGAudio.load("death2","sounds/243613__patricklieberkind__big-crash-b_cc_by");
	//JGAudio.load("bounce0","sounds/ivanbailey__1_cc_by-csharp");
	//JGAudio.load("bounce1","sounds/ivanbailey__1_cc_by-v1");
	//JGAudio.load("bounce2","sounds/ivanbailey__1_cc_by-e");
	//JGAudio.load("music","sounds/StarshipOrion_cc_by_Patashu");
	JGAudio.load("music","sounds/n121128_by_nwp8861-short");

	JGAudio.play("music","music",true);

	//tile_tex = initTexture(gl,"images/tile379736-37-26.561-filter.png",true,false);
	robot_texs.push(initTexture(gl,"images/robot1.png",false,false));
	robot_texs.push(initTexture(gl,"images/robot2.png",false,false));
	robot_texs.push(initTexture(gl,"images/robot3.png",false,false));
	robot_texs.push(initTexture(gl,"images/robot4.png",false,false));
	fish_texs.push(initTexture(gl,"images/fish-hd-1.png",false,false));
	fish_texs.push(initTexture(gl,"images/fish-hd-2.png",false,false));
	//fish_texs.push(initTexture(gl,"images/fish1.png",false,false));
	//fish_texs.push(initTexture(gl,"images/fish2.png",false,false));
	//fish_texs.push(initTexture(gl,"images/fish3.png",false,false));
	//fish_texs.push(initTexture(gl,"images/fish4.png",false,false));
	flower_texs.push(initTexture(gl,"images/flower1.png",false,false));
	flower_texs.push(initTexture(gl,"images/flower2.png",false,false));
	flower_texs.push(initTexture(gl,"images/flower3.png",false,false));
	flower_texs.push(initTexture(gl,"images/flower2.png",false,false));
	gnat_texs.push(initTexture(gl,"images/mosquito2.png",false,false));
	gnat_texs.push(initTexture(gl,"images/mosquito1.png",false,false));
	gnat_texs.push(initTexture(gl,"images/mosquito3.png",false,false));
	gnat_texs.push(initTexture(gl,"images/mosquito1.png",false,false));
	flyer_texs.push(initTexture(gl,"images/flyer1.png",false,false));
	flyer_texs.push(initTexture(gl,"images/flyer2.png",false,false));
	player_texs.push(initTexture(gl,"images/playerb1.png",false,false));
	player_texs.push(initTexture(gl,"images/playerb2.png",false,false));
	player_texs.push(initTexture(gl,"images/playerb3.png",false,false));
	player_texs.push(initTexture(gl,"images/playerb4.png",false,false));
	playertitle_tex=initTexture(gl,"images/playerfacing.png",false,false);
	star_texs.push(initTexture(gl,"images/Star_1c.png",true,false));
	star_texs.push(initTexture(gl,"images/Star_2c.png",true,false));
	star_texs.push(initTexture(gl,"images/Star_3c.png",true,false));
	star_texs.push(initTexture(gl,"images/Star_4c.png",true,false));
	star_texs.push(initTexture(gl,"images/Star_3c.png",true,false));
	star_texs.push(initTexture(gl,"images/Star_2c.png",true,false));
	bullet_tex = initTexture(gl,"images/explo2.png",true,false);
	seed_tex = initTexture(gl,"images/bullet.png",false,false);
	heart_tex = initTexture(gl,"images/pixabella_pyroheart1b.png",true,false);
	bg_texs.push(initTexture(gl,"images/ld05-pp-tiles.png",true,false));
	bg_texs.push(initTexture(gl,"images/wallp28d-1024-2.jpg",true,false));
	bg_texs.push(initTexture(gl,"images/nyan11-tile2-1024.jpg",true,false));
	bg_texs.push(initTexture(gl,"images/skies4c-1024x600.jpg",true,false));
	tile_texs.push(initTexture(gl,"images/tile1-12.png",false,false));
	tile_texs.push(initTexture(gl,"images/tilered.png",false,false));
	tile_texs.push(initTexture(gl,"images/tileblue.png",false,false));
	tile_texs.push(initTexture(gl,"images/tilegreenbrown2.png",false,false));



	//if (!music_started) {
	//	JGAudio.play("music","music",true);
	//	music_started=true;
	//}


	// create menus
	mainmenu = new JGMenu(drawLogo);
	mainmenu.addMenuItem(drawMenuItemStatic,selMenuStartGame,
		{ ypos: 210, text: "START GAME" });
	mainmenu.addMenuItem(drawMenuItemLevel,selMenuLevel,{ypos: 270});
	//mainmenu.addMenuItem(drawMenuItemSound,selMenuSound,{ypos: 500});
	//mainmenu.addMenuItem(drawMenuItemMusic,selMenuMusic,{ypos: 600});
	//mainmenu.addMenuItem(drawMenuItemDonate,selMenuDonate,{ypos: 700});

	var optionsmenu = new JGMenu(null,drawMenuItemStatic,
		{ ypos:350, text: "BACK" });
	mainmenu.addSubmenu(drawMenuItemStatic,optionsmenu,
		{ ypos:330, text: "OPTIONS" });
	optionsmenu.addMenuItem(drawMenuItemSound,selMenuSound,{ypos:220});
	optionsmenu.addMenuItem(drawMenuItemMusic,selMenuMusic,{ypos:280});

	var creditsmenu = new JGMenu(drawCredits,drawMenuItemStatic,
		{ ypos:490, text: "BACK" });
	mainmenu.addSubmenu(drawMenuItemStatic,creditsmenu,
		{ ypos:390, text: "CREDITS" });

	if (window.navigator.paymentSystem 
	&& window.navigator.paymentSystem.getType()=="ouya") {
		window.navigator.paymentSystem.init(
			"xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx");
		mainmenu.addMenuItem(drawMenuItemDonate,selMenuDonate,{ypos: 450});
	}

	// start animation
	webGLFrame();
}

function drawMenuItemStatic(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem,menuitem.userdata.text);
}

function drawMenuText(is_active,menu,menuitem,text) {
	var size = is_active ? 15+1*Math.sin(0.1*menu.animtimer) : 13;
	var thick = is_active ? 3.5 : 2.0;
	drawText(text,width/2, menuitem.userdata.ypos,
		size,size, thick, font_color, 0, is_active ? 0 : 0.5);
	return {x:width/6, width:2*width/3, y:menuitem.userdata.ypos-25, height:70};
}

function selMenuStartGame(menu) {
	eng.setGameState("Game",-1);
	eng.addGameState("NewLevel",150);
}


function drawMenuItemLevel(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "START AT LEVEL "+(startlevel+1));
}

function selMenuLevel(menu) {
	startlevel+=2;
	if (startlevel > 8) startlevel = 0;
}

function drawMenuItemDonate(is_active,menu,menuitem) {
	var st = window.navigator.paymentSystem.checkReceipt("super_pyro_runner_donation_0_99");
	return drawMenuText(is_active,menu,menuitem, st==1
		? "THANKS FOR YOUR DONATION!"
		: (st==-1  ? "DONATE $0.99" : "") );
}

function selMenuDonate(menu) {
	window.navigator.paymentSystem.requestPayment("super_pyro_runner_donation_0_99");
}


function drawMenuItemSound(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "SOUND " +
		(JGAudio.isEnabled() ? "ENABLED" : "DISABLED") );
}

function selMenuSound(menu) {
	if (JGAudio.isEnabled()) {
		JGAudio.disable();
	} else {
		JGAudio.enable();
	}
}
function selMenuMusic(menu) {
	if (JGAudio.isEnabled("music")) {
		JGAudio.disable("music");
	} else {
		JGAudio.enable("music");
		JGAudio.play("music","music",true);
	}
}

function drawMenuItemMusic(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "MUSIC " +
		(JGAudio.isEnabled("music") ? "ENABLED" : "DISABLED") );
}

function drawLogo(menu) {
	drawText("A TMTG.NET GAME",width/2,155,8,8,2,font_color,0,0.5);;
}

function drawCredits(menu) {
	drawText("GAME BY BORIS VAN SCHOOTEN",width/2,170,14,14,2.5,font_color,0,0.5);;
	drawText("MUSIC BY NWP8861",width/2,215,14,14,2.5,font_color,0,0.5);;
	drawText("GRAPHICS",width/2,260,12,12,2.5,font_color,0,0.5);;
	drawText("SKYLAR1146,PIXABELLA,GAMEARTFORGE.",width/2,290,10,10,2,font_color,0,0.5);;
	drawText("MOST OTHER GRAPHICS BY ACCIDENT.",width/2,320,10,10,2,font_color,0,0.5);
	drawText("SOUND FX",width/2,360,12,12,2.5,font_color,0,0.5);;
	drawText("FINS, TIM GORMLY, NOTHAYAMA, ZUT50,",width/2,390,10,10,2,font_color,0,0.5);;
	drawText("PATRICK LIEBERKIND, BONE66138,",width/2,420,10,10,2,font_color,0,0.5);;
	drawText("IVAN BAILEY, QUBODUP, ERIKH2000.",width/2,450,10,10,2,font_color,0,0.5);;
	//drawText("PACDV, ERIKH2000.",width/2,340,12,12,2,font_color,0,0.5);;
}


function webGLFrame() {
	// anim handling

	requestGLFrame(webGLFrame);

	var timeNow = new Date().getTime();
	if (lastTime != 0) {
		timeElapsed = timeNow - lastTime;
		gamespeed = timeElapsed / gamebasespeed;
		gamespeed = 1.0;
		gametime += gamespeed;
		totalgametime += gamespeed;
	}
	lastTime = timeNow;
	if (timeElapsed >= 1000/32) {
		frameskip=1;
		doWebGLFrame();
		lastTime = new Date().getTime();
	}
	frameskip=0;
	doWebGLFrame();
}

function doWebGLFrame() {

	// update touch controls
	touchcontrols = eng.sawTouchEvents();

	// read gamepads
	prevgamepadbut = gamepadbut;
	gamepadcontrols = false;
	gamepadmx = 0;
	gamepadmy = 0;
	gamepadfx = 0;
	gamepadfy = 0;
	gamepadbut = false;
	if (navigator.getGamepads) {
		var pads = navigator.getGamepads();
		// circumvent error in Chrome, which returns an array-like
		// thing on desktop that doesn't actually contain elements
		if (pads.length > 0 && pads[0]) {
			gamepadcontrols = true;
			// add up all values from all axes
			for (var i=0; i<pads.length; i++) {
				// circumvent possible errors
				if (!pads[i] || !pads[i].axes || !pads[i].buttons) continue;
				if (pads[i].axes[0] > 0.25 || pads[i].axes[0] < -0.25)
					gamepadmx += pads[i].axes[0];
				if (pads[i].axes[1] > 0.25 || pads[i].axes[1] < -0.25)
					gamepadmy += pads[i].axes[1];
				if (pads[i].axes[2] > 0.25 || pads[i].axes[2] < -0.25)
					gamepadfx += pads[i].axes[2];
				if (pads[i].axes[3] > 0.25 || pads[i].axes[3] < -0.25)
					gamepadfy += pads[i].axes[3];
				for (var b=0; b<4; b++) {
					if (pads[i].buttons[b].pressed) gamepadbut=true;
				}
				gamepaddx = 0;
				gamepaddy = 0;
				if (pads[i].buttons[12].pressed) gamepaddy = -1;
				if (pads[i].buttons[13].pressed) gamepaddy =  1;
				if (pads[i].buttons[14].pressed) gamepaddx = -1;
				if (pads[i].buttons[15].pressed) gamepaddx =  1;
			}
		}
	}



	// init gl

	gl.clearColor(0.0, 0.0, 0.0, 1.0);
	gl.disable(gl.DEPTH_TEST);
	gl.disable(gl.BLEND);
	//gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
	gl.blendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
	//gl.blendEquationSeparate(gl.FUNC_ADD, gl.FUNC_ADD);
	//gl.blendFuncSeparate(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA,
	//	gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
	// clear entire canvas
	gl.viewport(0, 0, gl.canvas.width, gl.canvas.height);
	gl.clear(gl.COLOR_BUFFER_BIT);
	//gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
	// then set viewport to preserve aspect ratio
	eng.updateViewport();
	gl.viewport(eng.viewportxofs,eng.viewportyofs,eng.viewportwidth,eng.viewportheight);


	drawLineInitFrame(width,height);
	drawLineSegmentsInitFrame(width,height);
	drawSpriteInitFrame(width,height);




	// game states:
	// Title - title screen
	// Game - remains active from start game till game over
	// During Game, the following states are found:
	//   NewLevel - start new level sequence
	//   LevelDone - finish current level sequence
	//   NewLife - start with new life sequence
	//   LifeLost - lose life sequence
	//   GameOver - game over sequence
	eng.handleGameStates(1,frameskip);

	if (bonussoundtrigger>=0) bonussoundtrigger--;

	if (!frameskip) {
		if (eng.inGameState("Title")) {
			font_color = [0,0,0,1];
		} else if (stage%4==2) {
			font_color = [1,1,1,1];
		} else {
			font_color = [0,0,0,1];
		}
		drawText(""+score,90,60,12,12,3,font_color,-1,0);
		if (eng.inGameState("Title")) {
			drawText("HIGH "+highscore,width/2,60,12,12,3,font_color,0,0);
		} else {
			for (var i=0; i<lives; i++) {
				drawSprite(width/2-70 + 40*i,42,38,33, 0,
					heart_tex,
					null, null, true);
			}
		}
		//drawText(""+lives,width/2,60,12,12,3,font_color,0,0);
		drawSprite(width-180,42,36,36, 0.02*gametime,
			star_texs[Math.floor(0.3*gametime) % star_texs.length],
			null, null, true);
		drawText(""+stars,width-125,60,12,12,3,font_color,-1,0);

		// mouse cursor

		var ang = Math.PI + Math.PI/4;
		var player = JGObject.getObject("player");
		var pointerx = eng.getMouseX();
		var pointery = eng.getMouseY();
		if (player) {
			if (player.fireofsx!=0 || player.fireofsy!=0) {
				pointerx = player.x + player.fireofsx - screenxofs;
				pointery = player.y + player.fireofsy;
				//console.log("######"+pointerx+" "+pointery);
			}
			ang = Math.atan2(pointerx - player.x + screenxofs,
							 pointery - player.y);
		}
		if (!gamepadcontrols  && (player || !touchcontrols)) {
			var color = cyclecol[Math.floor(gametime/4) % cyclecol.length];
			drawLine([pointerx,pointery], Math.PI-ang, 20.0, 2,
				color, unit_arrow, unit_arrow.length/2, true, "unit_arrow");
		}

	}

}

function checkTime(start,end,period) {
	return (gametime >= start && gametime < end && gametime%period<gamespeed);
}


// game states: transitions

var music_started=false;

function startGame(timer) {
	//if (window.navigator.paymentSystem) 
	//	window.navigator.paymentSystem.requestPayment("tsunami_cruiser_donate_0_99");
	score = 0;
	level = startlevel;
	stage = startlevel;
	lives = 3;
}

function startNewLevel(timer) {
	lives = 3;
	stars = level < 6 ? 10 + 10*level : 60;
	JGObject.removeObjects(null,0);
	gametime=0;
	//JGAudio.play("startlevel");
	tilemap = new JGTileMap(gl,36,36,15*20,17, -1, 0,
		tile_texs[stage % tile_texs.length], 12,12);

	var in_gap=false;
	var island_type=0;
	var flyer_type = level%2;
	var block_size = level==0 ? 35 : 15;
	var total_block_size=block_size;
	var block_height=3;
	var time_till_next_jumper=30;
	var time_till_next_flyer=26;
	var time_till_next_flyertype = level>0 ? 10 : 10000;
	var time_till_next_fish=level > 1 ? 10 : 10000;
	var time_till_next_flowerisl = level>2 ? 2 : 10000;
	var time_till_next_flower = level>2 ? 2 : 10000;
	var difficulty = level > 8 ? 4 : Math.floor(level/2);
	for (var x=0; x<tilemap.nrtilesx; x++) {
		//var difficulty = x*5 / tilemap.nrtilesx; // 0...4
		if (!in_gap) {
			for (var y=tilemap.nrtilesy-block_height;
			y<tilemap.nrtilesy; y++) {
				tilemap.setTile(0,1,x,y);
			}
			if (island_type==0) {
				time_till_next_jumper--;
				if (time_till_next_jumper<=0) {
					time_till_next_jumper = randomstep(5-difficulty,7-difficulty,1);
					new Jumper(x,tilemap.nrtilesy-block_height-1);
				}
			} else { //1
				time_till_next_flower--;
				if (time_till_next_flower<=0) {
					time_till_next_flower = randomstep(6-difficulty,8-difficulty,1);
					new Flower(x,tilemap.nrtilesy-block_height-1,
						block_size / total_block_size);
				}
			}
			block_size--;
			if (block_size<=0) {
				in_gap=true;
				block_size = randomstep(2+difficulty/2,3+difficulty,1);
				total_block_size = block_size;
			}
		} else {
			block_size--;
			if (block_size<=0) {
				in_gap=false;
				block_size = randomstep(9-difficulty,13-difficulty,1);
				total_block_size = block_size;
				if (block_height<=2) {
					block_height += randomstep(1,3,1);
				} else if (block_height >= 8) {
					block_height += randomstep(-3,-1,1);
				} else {
					block_height += randomstep(-3,3,1);
				}
				if (block_height<2) block_height=2;
				if (block_height>8) block_height=8;
				// get island type
				time_till_next_flowerisl--;
				if (time_till_next_flowerisl<=0 && x < tilemap.nrtilesx-10) {
					island_type=1;
					time_till_next_flowerisl = randomstep(2,3,1);
				} else {
					island_type=0;
				}
			} else {
				time_till_next_fish--;
				if (time_till_next_fish<=0) {
					time_till_next_fish = randomstep(6-difficulty,9-difficulty,1);
					new Fish(x,tilemap.nrtilesy);
				}
			}
		}
		time_till_next_flyer--;
		if (time_till_next_flyer<=0) {
			time_till_next_flyer = randomstep(7-difficulty,10-difficulty,1);
			if (flyer_type==0) {
				new Flyer(x,tilemap.nrtilesy-block_height-randomstep(3,7,1));
			} else {
				new Gnat(x,randomstep(-3,0,1));
			}
			if (time_till_next_flyertype-- <= 0) {
				flyer_type = (flyer_type+1)%2;
				time_till_next_flyertype = random(8,15);
			}
		}
	}

	new Player(2,tilemap.nrtilesy-4);

	tilemap.update(gl);
}

function startLifeLost(timer) {
}

function endLifeLost(timer) {
	lives--;
	if (lives<=0) {
		eng.addGameState("GameOver",200);
	} else {
		eng.addGameState("NewLife",150);
	}
}

function endGameOver(timer) {
	//JGObject.removeObjects(null,0);
	totalgametime=0;
	gametime=0;
	if (score > highscore && localStorage) {
		highscore = score;
		localStorage.setItem("highscore",highscore);
	}
	eng.setGameState("Title",-1);
}

// game states: updates and paints

function doFrameGame(timer) {
	var player = JGObject.getObject("player");
	if (player) {
		screenxofs = player.x - 36*4;
		if (player.hitstop > 0) screenxofs += 6.0*Math.sin(player.hitstop);
	} else {
		//screenxofs = 0;
	}
	// update state

	if (!frameskip) {
		drawSprite(0,0,width,height, 0, 
			bg_texs[Math.floor(stage) % bg_texs.length],
			null, null, true);
		tilemap.draw(gl,screenxofs,0);
	}
	JGObject.updateObjects(gl,frameskip,screenxofs,0,width,height);

	JGObject.checkCollision(4+8,1); // enemies, bonus hit player
	JGObject.checkCollision(2,4); // bullets hit enemies
	JGObject.checkBGCollision(tilemap,255,1+2+4+8); // all tiles hit all
}

function paintFrameGame(timer) {
	if (level==0) { // instructions
		var col = hsv_to_rgb((gametime/20)%1,1.0,0.66,1.0);
		if (gametime>50 && gametime < 330) {
			if (gamepadcontrols) {
				drawText("O, U, Y, A TO JUMP.",width/2,280,17,17,2.5,col,0,0.5);
				if (gametime>100) {
					drawText("USE YOUR TRIPLE JUMP!",width/2,340,17,17,2.5,col,0,0.5);
				}
			} else if (touchcontrols) {
				drawText("TOUCH LEFT SIDE",width/4,250,13,13,2.5,col,0,0.5);
				drawText("TO JUMP.",width/4,290,13,13,2.5,col,0,0.5);
				if (gametime>100) {
					drawText("USE YOUR",width/4,340,13,13,2.5,col,0,0.5);
					drawText("TRIPLE JUMP!",width/4,380,13,13,2.5,col,0,0.5);
				}
			} else {
				drawText("CLICK TO JUMP.",width/2,280,17,17,2.5,col,0,0.5);
				if (gametime>100) {
					drawText("USE YOUR TRIPLE JUMP!",width/2,340,17,17,2.5,col,0,0.5);
				}
			}
		} else if (gametime>350 && gametime < 550) {
			if (gamepadcontrols) {
				drawText("USE STICK TO AIM.",width/2,280,17,17,2.5,col,0,0.5);
			} else if (touchcontrols) {
				drawText("SWIPE RIGHT SIDE",3*width/4-30,260,13,13,2.5,col,0,0.5);
				drawText("TO AIM.",3*width/4,300,13,13,2.5,col,0,0.5);
			} else {
				drawText("USE MOUSE TO AIM.",width/2,280,17,17,2.5,col,0,0.5);
			}
		}
	}
}

function startTitle(timer) {
	JGObject.removeObjects(null,0);
	//for (var i=0; i<5; i++) 
	//	new Fish();
	eng.clearMouseButton(1);
	tilemap = new JGTileMap(gl,36,36,29,17, -1, 0,
		tile_texs[0], 12,12);
	for (var x=5; x<24; x++) {
		for (var y=15; y<17; y++) {
			tilemap.setTile(0,1,x,y);
		}
	}
	tilemap.update(gl);
	curmenu = mainmenu;
}


function doFrameTitle(timer) {
	/*if ((gamepadcontrols && gamepadbut)
	||  (!gamepadcontrols && (eng.getMouseButton(1) || eng.getKey(' ')))
	) {
		eng.setGameState("Game",-1);
		eng.addGameState("NewLevel",150);
		//eng.addGameState("NewLife",150);
		eng.clearMouseButton(1);
	}*/
	curmenu = curmenu.update(!gamepadcontrols,eng.getMouseX(),eng.getMouseY(),
		(eng.getMouseButton(1) && !touchcontrols && !gamepadcontrols)
		|| (!gamepadcontrols && eng.touches.length>0),
			gamepadmy<-0.7 || gamepadfy<-0.7 || gamepaddy < -0.5,
			gamepadmy> 0.7 || gamepadfy> 0.7 || gamepaddy > 0.5,
			gamepadbut);
}

function paintFrameTitle(timer) {
	if (!frameskip) {
		drawSprite(0,0,width,height, 0, 
			bg_texs[0],
			null, null, true);
		tilemap.draw(gl,0,0);
	}
	var at = gametime%1000;
	var x = width/2-18;
	var y = 14*tilemap.tiley;
	if (at < 400) {
		drawSprite(x,y,36,36, 0,
			playertitle_tex, null, null, true);
	} else if (at<550) { // walk left
		x -= 2.0*(at-400) - 36;
		drawSprite(x,y,-36,36, 0,
			player_texs[Math.floor(0.2*gametime) % player_texs.length],
			null, null, true);
	} else if (at<850) { // walk right
		x = x - 2.0*150 + 2.0*(at-550);
		drawSprite(x,y,36,36, 0,
			player_texs[Math.floor(0.2*gametime) % player_texs.length],
			null, null, true);
	} else if (at<1000) { // walk left to middle
		x = x + 2.0*150 - 2.0*(at-850) + 36;
		drawSprite(x,y,-36,36, 0,
			player_texs[Math.floor(0.2*gametime) % player_texs.length],
			null, null, true);
	}
	curmenu.paint();
	drawText("SUPER PYRO RUNNER",width/2,120,17,17,3.5,font_color,0,1.0);
	//drawText("GET STARS TO FINISH LEVEL",width/2,180,12,12,3.5,[1.0,1.0,1.0,1.0],0,0);
	if (gamepadcontrols) {
		//drawText("PRESS O TO START",width/2,200,17,17,3.5,[1.0,1.0,1.0,1.0],0,0);
	} else {
		//drawText("CLICK TO START",width/2,200,17,17,3.5,[1.0,1.0,1.0,1.0],0,0);
	}
	//drawText("START LEVEL "+(startlevel+1),width/2,270,17,17,3.5,[1.0,1.0,1.0,1.0],0,0);
	//if (window.navigator.paymentSystem) 
	//	drawText("DONATION!" + window.navigator.paymentSystem.checkReceipt(
	//		"tsunami_cruiser_donate_0_99"),
	//		width/2,470,12,12,1.5,[1.0,1.0,1.0,1.0],0,2);
	//drawText("MOUSE BUTTON TO TOGGLE FIRE",width/2,430,12,12,1.5,[1.0,1.0,1.0,1.0],0,0);

}

function texteasing(timer) {
	if (timer < 20) return {size:1, alpha: timer/20};
	if (timer < 130) return {size:1, alpha:1.0};
	return {
		size: 1 + 2*((timer-130)/20),
		alpha: 1.0 - (timer-130)/20
	};
}

function paintFrameLevelDone(timer) {
	var ea = texteasing(timer);
	var col = [font_color[0],font_color[1],font_color[2],ea.alpha];
	drawText("CLEARED LEVEL "+(stage+1),width/2,180,17*ea.size,17*ea.size,3.5*ea.size,
		col,0,1.0);
}

function endLevelDone(timer) {
	level++;
	stage++;
	if (level > startlevel) startlevel = level;
	eng.addGameState("NewLevel",150);
}

function paintFrameNewLevel(timer) {
	var ea = texteasing(timer);
	var col = [font_color[0],font_color[1],font_color[2],ea.alpha];
	drawText("GET READY!",width/2,200,17*ea.size,17*ea.size,ea.size*3.5,
		col,0,1.0);
	drawText("LEVEL "+(stage+1),width/2,120,17*ea.size,17*ea.size,ea.size*3.5,
		col,0,1.0);
}

function paintFrameNewLife(timer) {
}

function paintFrameLifeLost(timer) {
	drawText("TRY AGAIN!",width/2,180,17,17,3.5,
		font_color,0,1.0);
}

function paintFrameGameOver(timer) {
	var ea = texteasing(timer);
	var col = [font_color[0],font_color[1],font_color[2],ea.alpha];
	drawText("LEVEL FAILED!",width/2,180,17*ea.size,17*ea.size,3.5*ea.size,
		col,0,1.0);
}


// ---------------------------------------------------------
// Star
// ---------------------------------------------------------



function Star(x,y,xspeed,yspeed,falling) {
	JGObject.apply(this,["star",true,x,y, 8]);
	if (falling) {
		this.xspeed = random(-3.0,3.0) + 0.3*xspeed;
		this.yspeed = 0.3*yspeed - random(5.0,9.0);
	}
	this.setBBox(-8,-8,56,56);
	this.setExpireOffscreen(36,200);
	this.animtimer=0;
	this.stopped=false;
	if (falling) this.falling=true;
	this.expiry = -1;
}

Star.prototype = new JGObject();

Star.prototype.move = function() {
	this.animtimer += 1.0;
	if (this.expiry >= 0) {
		this.expiry--;
		if (this.expiry<=0) this.remove();
		return;
	}
	if (!this.falling) return;
	if (!this.stopped) {
		this.yspeed += 0.2;
		this.xspeed *= 0.98;
	}
}

Star.prototype.hit_bg = function(tilecid) {
	var cen = this.getCenterTile(tilemap);
	var tciddown = tilemap.getTileCidPos(cen.x,cen.y+1);
	//var tcid_lr = tilemap.getTileCidPos(cen.x+1,cen.y)
	//               + tilemap.getTileCidPos(cen.x+1,cen.y-1)
	//               + tilemap.getTileCidPos(cen.x+1,cen.y)
	//               + tilemap.getTileCidPos(cen.x+1,cen.y-1);
	if (tciddown!=0) {
		this.x = this.lastx;
		this.y = this.lasty;
		this.yspeed = -0.7*this.yspeed;
		this.xspeed = 0.6*this.xspeed;
		if (this.yspeed > -2) {
			this.stopped=true;
			this.xspeed = 0;
			this.yspeed = 0;
			//this.snapToGrid(0,36);
		} else {
			JGAudio.play("bounce"+randomstep(0,2,1));
		}
	} else {//if (tcid_lr!=0) {
		this.xspeed = 0;
		this.snapToGrid(36,0);
	}
}


Star.prototype.paint = function(gl) {
	var size = 48;
	var col = this.falling ? [1,0.3,0.4,1] : null;
	if (this.expiry>=0) {
		var phase = (20 - this.expiry)/20;
		size = 48 + 500*phase*phase*phase*phase;
		if (!col) {
			col = [1,1,1, this.expiry/20];
		} else {
			col[3] = this.expiry/20;
		}
		gl.enable(gl.BLEND);
	}
	var ofs = (size-36)/2;
	//drawText("A",100,100,12,12,1,[1.0,1.0,1.0,1.0],-1,0);
	drawSprite(this.x-screenxofs-ofs,this.y-ofs,size,size, -0.05*this.x,
		star_texs[Math.floor(0.3*this.animtimer) % star_texs.length],
		null, col, true);
	if (this.expiry>=0) gl.disable(gl.BLEND);
}


// ---------------------------------------------------------
// Gnat
// ---------------------------------------------------------



function Gnat(tx,ty) {
	JGObject.apply(this,["enemy",true,tx*tilemap.tilex,ty*tilemap.tiley, 4]);
	this.setBBox(0,0,36,36);
	this.animtimer=0;
	this.setSuspendOffscreen(36,300);
	this.hp = 1;
	this.yspeed = random(1.0,2.0);
	this.xspeed = random(-1.0,0.0);
	this.movetimer = 0;
	this.movespeed = random(1.0,2.0);
	this.landed = false;
}

Gnat.prototype = new JGObject();

Gnat.prototype.move = function() {
	if (this.landed) return;
	this.animtimer += 1.0;
	this.movetimer += this.movespeed;
	this.x += Math.sin(0.05*this.movetimer);
	this.y += Math.cos(0.054*this.movetimer);
}

Gnat.prototype.hit = function(obj) {
	new Explo(this.x,this.y,this.xspeed*0.5,this.yspeed*0.5);
	if (this.hp-- > 0) return;
	obj.remove();
	this.remove();
	new Star(this.x,this.y,this.xspeed,this.yspeed,false);
	createExplo(this.x,this.y,this.xspeed,this.yspeed,12);
	score += 5;
}

Gnat.prototype.hit_bg = function(tilecid) {
	this.xspeed = 0;
	this.yspeed = 0;
	this.landed=true;
	this.animtimer=4;
	this.snapToGrid(0,36);
}


Gnat.prototype.paint = function(gl) {
	drawSprite(this.x-screenxofs,this.y,36,36, 0,
		gnat_texs[Math.floor(0.33*this.animtimer) % gnat_texs.length],
		null, null, true);
}


// ---------------------------------------------------------
// Flower
// ---------------------------------------------------------


// blockpos: 0 = left, 1 = right
function Flower(tx,ty,blockpos) {
	JGObject.apply(this,["enemy",true,tx*tilemap.tilex,ty*tilemap.tiley, 4]);
	this.setBBox(0,0,36,36);
	this.animtimer=0;
	this.blockpos = blockpos;
	this.bullettimer = random(140,180);
	this.setSuspendOffscreen(36,36);
	this.hp = 6;
	this.animspeed = random(0.7,1.0);
}

Flower.prototype = new JGObject();

Flower.prototype.move = function() {
	this.animtimer += this.animspeed;
	var player = JGObject.getObject("player");
	if (Math.floor(this.bullettimer)==3 && player)
		JGAudio.play("spit"+randomstep(0,1,1));
	if (this.bullettimer-- <= 0) {
		this.bullettimer = 80;
		if (player) {
			//var ang = Math.atan2(player.x-this.x,player.y-this.y);
			var ang = Math.PI*(0.72 + 1.0*this.blockpos);
			new Seed(this.x,this.y, 2.5*Math.sin(ang),2.5*Math.cos(ang));
		}
	}
}

Flower.prototype.hit = function(obj) {
	new Explo(this.x,this.y,this.xspeed*0.5,this.yspeed*0.5);
	if (this.hp-- > 0) return;
	obj.remove();
	this.remove();
	new Star(this.x,this.y-16,0,0,true);
	new Star(this.x,this.y-16,0,0,true);
	JGAudio.play("pop"+randomstep(0,2,1));
	createExplo(this.x,this.y,this.xspeed,this.yspeed,12);
	score += 15;
	//playAudio("roof-kill"+random(1,3,1));
}

Flower.prototype.paint = function(gl) {
	//drawText("A",100,100,12,12,1,[1.0,1.0,1.0,1.0],-1,0);
	drawSprite(this.x-screenxofs,this.y,36,36, 0,
		flower_texs[Math.floor(0.3*this.animtimer) % flower_texs.length],
		null, null, true);
}

function Seed(x,y,xspeed,yspeed) {
	JGObject.apply(this,["enemy",true,x,y, 4]);
	this.setBBox(8,8,20,20);
	this.animtimer=0;
	this.setExpireOffscreen(36,36);
	this.xspeed = xspeed;
	this.yspeed = yspeed - random(5.0,6.0);
}

Seed.prototype = new JGObject();

Seed.prototype.move = function() {
	this.animtimer += 1.0;
	this.yspeed += 0.06;
}

//Seed.prototype.hit_bg = function(tilecid) {
//	this.remove();
//}

Seed.prototype.paint = function(gl) {
	var col = hsv_to_rgb((this.animtimer/20)%1,1.0,1.0,0.75);
	//drawText("A",100,100,12,12,1,[1.0,1.0,1.0,1.0],-1,0);
	drawSprite(this.x-screenxofs,this.y,36,36, 0,
		seed_tex,
		null, col, true);
}


// ---------------------------------------------------------
// Fish
// ---------------------------------------------------------



function Fish(tx,ty) {
	JGObject.apply(this,["enemy",true,tx*tilemap.tilex,ty*tilemap.tiley, 4]);
	this.setBBox(0,0,36,36);
	this.jumptimer=random(10,30);
	this.animtimer=0;
	this.setSuspendOffscreen(36,200);
	this.hp = 2;
}

Fish.prototype = new JGObject();

Fish.prototype.move = function() {
	this.animtimer += 1.0;
	if (this.y < height || this.yspeed<0) {
		this.yspeed += 0.2;
	} else {
		this.yspeed = 0;
		if (this.jumptimer>0) {
			this.jumptimer--;
		} else {
			this.yspeed = random(-10,-16);
			this.jumptimer=random(30,60);
		}
	}
}

Fish.prototype.hit = function(obj) {
	obj.xspeed *= 0.3;
	obj.yspeed *= 0.3;
	obj.colid = 0;
	obj.expiry = 8;
	new Explo(this.x,this.y,this.xspeed*0.5,this.yspeed*0.5);
	if (this.hp-- > 0) return;
	obj.remove();
	this.remove();
	new Star(this.x,this.y,this.xspeed+5*3,this.yspeed,true);
	new Star(this.x,this.y,this.xspeed+5*3,this.yspeed,true);
	new Star(this.x,this.y,this.xspeed+5*3,this.yspeed,true);
	JGAudio.play("pop"+randomstep(0,2,1));
	createExplo(this.x,this.y,this.xspeed,this.yspeed,12);
	score += 10;
	//playAudio("roof-kill"+random(1,3,1));
}


Fish.prototype.paint = function(gl) {
	//drawText("A",100,100,12,12,1,[1.0,1.0,1.0,1.0],-1,0);
	drawSprite(this.x-screenxofs,this.y,36,36, this.yspeed<0 ? 0 : Math.PI,
		fish_texs[Math.floor(0.1*this.animtimer) % fish_texs.length],
		null, null, true);
}



// ---------------------------------------------------------
// Flyer
// ---------------------------------------------------------



function Flyer(tx,ty) {
	JGObject.apply(this,["enemy",true,tx*tilemap.tilex,ty*tilemap.tiley, 4]);
	this.setBBox(0,0,36,36);
	this.animtimer=0;
	this.movetimer=0;
	this.movespeed = random(0.015,0.05);
	this.xspeed=random(-1,-2);
	this.setSuspendOffscreen(36,36);
	this.hp = 1;
}

Flyer.prototype = new JGObject();

Flyer.prototype.move = function() {
	this.animtimer -= 0.5*this.xspeed;
	this.y += 2.0*Math.sin(this.movetimer);
	this.movetimer += this.movespeed;
}

Flyer.prototype.hit = function(obj) {
	obj.xspeed *= 0.3;
	obj.yspeed *= 0.3;
	obj.colid = 0;
	obj.expiry = 8;
	new Explo(this.x,this.y,this.xspeed*0.5,this.yspeed*0.5);
	if (this.hp-- > 0) return;
	obj.remove();
	this.remove();
	new Star(this.x,this.y,this.xspeed,this.yspeed);
	createExplo(this.x,this.y,this.xspeed,this.yspeed,9);
	score += 5;
	//JGAudio.play("explou"+random(0,2,1));
}


Flyer.prototype.paint = function(gl) {
	//drawText("A",100,100,12,12,1,[1.0,1.0,1.0,1.0],-1,0);
	drawSprite(this.x-screenxofs,this.y,36,36, 0,
		flyer_texs[Math.floor(0.25*this.animtimer) % flyer_texs.length],
		null, null, true);
}



// ---------------------------------------------------------
// Jumper
// ---------------------------------------------------------



function Jumper(tx,ty) {
	JGObject.apply(this,["enemy",true,tx*tilemap.tilex,ty*tilemap.tiley, 4]);
	this.setBBox(0,0,36,36);
	this.jumping=false;
	this.jumped=false;
	this.jumpdist=random(200,450);
	this.animtimer=0;
	this.animspeed=0;
	this.setSuspendOffscreen(36,200);
	this.hp = 1;
}

Jumper.prototype = new JGObject();

Jumper.prototype.move = function() {
	var player = JGObject.getObject("player");
	if (!this.jumping && !this.jumped && player!=null) {
		if (this.x-player.x < this.jumpdist) {
			this.yspeed = random(-6.0,-13.0);
			this.xspeed = random(-5,-1);
			this.jumping=true;
		}
	}
	this.animspeed = 0.2;
	if (this.jumping && !this.jumped) {
		this.yspeed += 0.2;
		this.animspeed = 0;
	}
	if (this.y >= height) this.remove();
	this.animtimer += this.animspeed;
}

Jumper.prototype.hit = function(obj) {
	obj.xspeed *= 0.3;
	obj.yspeed *= 0.3;
	obj.colid = 0;
	obj.expiry = 8;
	new Explo(this.x,this.y,this.xspeed*0.5,this.yspeed*0.5);
	if (this.hp-- > 0) return;
	obj.remove();
	this.remove();
	new Star(this.x,this.y,this.xspeed,this.yspeed);
	createExplo(this.x,this.y,this.xspeed,this.yspeed,9);
	score += 5;
	//playAudio("roof-kill"+random(1,3,1));
}

Jumper.prototype.hit_bg = function(tilecid) {
	this.snapToGrid(36,36);
	this.jumped=true;
	this.yspeed=0;
	this.xspeed=0;
}

Jumper.prototype.paint = function(gl) {
	//drawText("A",100,100,12,12,1,[1.0,1.0,1.0,1.0],-1,0);
	drawSprite(this.x-screenxofs,this.y,36,36, 0,
		robot_texs[Math.floor(this.animtimer) % robot_texs.length],
		null, null, true);
}

// --------------------------------------------------------------------
// EXPLO
// --------------------------------------------------------------------

function createExplo(x,y,xspeed,yspeed,size) {
	JGAudio.play("explou"+randomstep(0,2,1));
	for (var i=0; i<size; i++) {
		new Explo(x+random(-7,7),y+random(-7,7),
			0.5*xspeed + random(-4,4),
			0.5*yspeed + random(-4,4));
	}
}


function Explo(x,y,xspeed,yspeed) {
	JGObject.apply(this,["explo",true,x,y, 0]);
	this.setExpireOffscreen(36,36);
	this.xspeed = xspeed;
	this.yspeed = yspeed;
	this.expiry = random(20,30);
	this.ang = random(0,6);
	this.rot = random(-0.1,0.1);
}

Explo.prototype = new JGObject();

Explo.prototype.move = function() {
	if (this.expiry-- < 0) this.remove();
	this.ang += this.rot;
	this.xspeed *= 0.92;
	this.yspeed *= 0.92;
}

Explo.prototype.paint = function(gl) {
	gl.enable(gl.BLEND);
	var phase = 1.0 - this.expiry/30;
	drawSprite(this.x-screenxofs,this.y,30+30*phase,30+30*phase, this.ang,
		bullet_tex,
		null, [1.0-0.4*phase,1.0-0.7*phase,1.0-0.9*phase,1.0 - 0.9*phase],true);
	gl.disable(gl.BLEND);
}


// --------------------------------------------------------------------
// PLAYER
// --------------------------------------------------------------------


function Player(tx,ty) {
	JGObject.apply(this,["player",false,tx*tilemap.tilex,ty*tilemap.tiley, 1]);
	this.setTileBBox(0,0,36,36);
	this.setBBox(10,10,16,16);
	this.jumping=0;
	this.blocked=false;
	this.falling=false;
	this.animtimer=0;
	this.doublejump=false;
	this.bullettimer=0;
	this.immune=0;
	this.hitstop=0;

	this.fireofsx=0;
	this.fireofsy=0;
	this.firetouch=false;
	this.firecenx=-1;
	this.fireceny=-1;
	this.movetouch = false;
	this.prevmovetouch = false;
}

Player.prototype = new JGObject();

Player.prototype.move = function() {
	if (eng.inGameState("LevelDone")) {
		this.xspeed = 0;
		this.yspeed -= 0.14;
		return;
	}
	if (this.hitstop>0) this.hitstop--;
	if (this.immune>0) this.immune--;

	if (gamepadcontrols) {
		this.fireofsx = gamepadfx+gamepadmx;
		this.fireofsy = gamepadfy+gamepadmy;
	} else if (touchcontrols) {
		var firefound = false;
		var movefound = false;
		this.prevmovetouch = this.movetouch;
		for (var i=0; i<eng.touches.length; i++) {
			var touch = eng.touches[i];
			if (touch.x < width/2) {
				// jump
				this.movetouch = true;
				movefound = true;
			} else {
				// fire
				if (this.firetouch) {
					this.fireofsx += 3.0*(touch.x - this.firecenx);
					this.fireofsy += 3.0*(touch.y - this.fireceny);
				}
				this.firecenx = touch.x;
				this.fireceny = touch.y;
				this.firetouch = true;
				firefound=true;
			}
		}
		if (!firefound) this.firetouch = false;
		if (!movefound) this.movetouch = false;
		// if fireofs too large, reduce it gradually
		var cendist = this.fireofsx*this.fireofsx + 
					  this.fireofsy*this.fireofsy;
		if (cendist > 150*150) {
			var cenang = Math.atan2(this.fireofsx,this.fireofsy);
			cendist = Math.sqrt(cendist);
			this.fireofsx = 0.995*cendist*Math.sin(cenang);
			this.fireofsy = 0.995*cendist*Math.cos(cenang);
		}
	} else {
		this.fireofsx = eng.getMouseX() - this.x + screenxofs;
		this.fireofsy = eng.getMouseY() - this.y;
	}


	if (!this.blocked) {
		this.x += 3.0;
		if (!this.falling) {
			if ((!this.prevmovetouch && this.movetouch)
			||  (!touchcontrols && eng.getMouseButton(1))
			||  ( gamepadbut && !prevgamepadbut) ) {
				eng.clearMouseButton(1);
				if (this.jumping < 3) {
					JGAudio.play("jump"+this.jumping);
					this.jumping++;
					this.yspeed = -12;
				}
			}
		}
	}
	if (!this.jumping && !this.falling) {
		var cen = this.getCenterTile(tilemap);
		var tciddown = tilemap.getTileCidPos(cen.x,cen.y+1);
		if (tciddown==0) {
			this.jumping=1;
			//this.falling=true;
		}
	}
	if (this.jumping || this.falling) {
		if (this.yspeed<10) this.yspeed += 0.5;
	} else {
		this.animtimer += 0.2;
	}
	if (this.x>=tilemap.pfwidth) {
		//gameOver();
	}
	if (this.y > tilemap.pfheight) {
		//gameOver();
		this.remove();
		JGAudio.play("death"+randomstep(0,2,1));
		eng.addGameState("GameOver",150);
		//PlayerExplo(x,y);
	}


	if (this.bullettimer<=0) {
		//if (JGObject.countObjects("bullet",0) < 12) {
			//playAudio("roof-shoot"+random(1,3,1));
			if (this.fireofsx || this.fireofsy) {
				var ang = Math.atan2(this.fireofsx, this.fireofsy);
				new Bullet(this.x,this.y,this.yspeed,ang);
				this.bullettimer=2;
				/*if (gamepadcontrols) {
					if (gamepadmx+gamepadfx || gamepadmy+gamepadfy) {
						new Bullet(this.x,this.y,this.yspeed,ang);
						this.bullettimer=2;
					}
				} else {
					new Bullet(this.x,this.y,this.yspeed,ang);
					this.bullettimer=2;
				}*/
			}
		//}
	} else {
		this.bullettimer--;
	}
}

Player.prototype.hit = function(obj) {
	if (eng.inGameState("LevelDone")) return;
	if (obj.colid==8) {
		obj.colid = 0;
		obj.expiry = 20;
		obj.yspeed = -6.0;
		stars--;
		score += 10;
		if (bonussoundtrigger<=0) {
			JGAudio.play("bonus"+(obj.falling ? "a":"b")+randomstep(0,2,1));
			bonussoundtrigger=1;
		}
		if (stars<=0) {
			this.yspeed=0;
			eng.addGameState("LevelDone",150);
			JGAudio.play("leveldone");
		}
		//obj.remove();
	} else {
		if (this.immune > 0) return;
		obj.remove();
		this.hitstop=8;
		JGAudio.play("ouch0");
		lives--;
		if (lives >= 1) {
			this.immune = 100;
		} else {
			this.falling=true;
			this.colid=0;
			this.bullettimer=1000;
			//this.remove();
			//eng.addGameState("GameOver",100);
		}
	}
}

Player.prototype.hit_bg = function(tilecid) {
	var cen = this.getCenterTile(tilemap);
	var tcidcen = tilemap.getTileCidPos(cen.x,cen.y);
	var tciddown = tilemap.getTileCidPos(cen.x,cen.y+1);
	var tcidright = tilemap.getTileCidPos(cen.x+1,cen.y)
	               + tilemap.getTileCidPos(cen.x+1,cen.y-1);
	if (tcidcen!=0) {
		this.x -= tilemap.tilex;
	} else {
		if (tcidright!=0) {
			this.snapToGrid(36,0);
			this.blocked=true;
		}
		if (tciddown!=0) {
			this.snapToGrid(0,36);
			this.jumping=0;
			this.falling=false;
			this.doublejump=false;
			this.yspeed=0;
		}
	}
}


Player.prototype.paint = function(gl) {
	var col=null;
	if (this.hitstop > 0) {
		col = [0,0,0,1];
	} else {
		if (this.immune > 0 && Math.floor(this.immune/2)%2 == 0) return;
	}
	var tex;
	if (eng.inGameState("LevelDone")) {
		tex = playertitle_tex;
	} else {
		tex = player_texs[Math.floor(this.animtimer) % player_texs.length];
	}
	drawSprite(this.x-screenxofs,this.y,36,36, 0,
		tex, null, col, true);
}



function Bullet(x,y,yspeed,angle) {
	JGObject.apply(this,["bullet",true,x,y, 2]);
	this.setBBox(6,6,24,24);
	this.setExpireOffscreen(36,200);
	this.bounces=0;
	this.xspeed = 3.0 + 12.0*Math.sin(angle);
	this.yspeed = 0.2*yspeed + 12.0*Math.cos(angle);
	this.x += this.xspeed;
	this.y += this.yspeed;
	this.expiry = 30;
	this.ang = random(0,6);
	this.rot = random(-0.1,0.1);
}

Bullet.prototype = new JGObject();

Bullet.prototype.move = function() {
	//if (this.x<screenxofs || this.x>screenxofs+width
	//||  this.y<0 || this.y>height) this.remove();
	//this.yspeed += 0.4;
	if (this.expiry-- < 0) this.remove();
	this.ang += this.rot;
}

Bullet.prototype.hit_bg = function(tilecid) {
	return;
	// bounce code unused
	var cen = this.getCenterTile(tilemap);
	var tciddown = tilemap.getTileCidPos(cen.x,cen.y+1);
	var tcidright = tilemap.getTileCidPos(cen.x+1,cen.y)
	               + tilemap.getTileCidPos(cen.x+1,cen.y-1);
	if (tcidright!=0) this.remove();
	if (this.yspeed>0) {
		this.yspeed = -0.9*this.yspeed;
		this.bounces--;
		if (this.bounces<=0) this.remove();
	}
}

Bullet.prototype.paint = function(gl) {
	gl.enable(gl.BLEND);
	var phase = 1.0 - this.expiry/30;
	drawSprite(this.x-screenxofs,this.y,35+25*phase,35+25*phase, this.ang,
		bullet_tex,
		null, [1.0,1.0,1.0,1.0 - 0.7*phase], true);
	gl.disable(gl.BLEND);
}



